from perxis.collections import collections_pb2
from dataclasses import dataclass, asdict
from typing_extensions import deprecated


@deprecated("This function is deprecated. Use `init_collections` instead.")
def make_collection_instances(
    schemes_dir: str, schemes_mapping: dict[str, str]
) -> list[collections_pb2.Collection]:
    collections = []

    for collection_id, collection_name in schemes_mapping.items():
        with open(f"{schemes_dir}/{collection_id}.json", "r") as file:
            collection_schema = file.read()

        collection = collections_pb2.Collection(
            id=collection_id,
            name=collection_name,
            schema=collection_schema
        )
        collections.append(collection)
    return collections


@dataclass
class CollectionProps:
   single: bool = False
   system: bool = False
   no_data: bool = False
   hidden: bool = False
   no_revisions: bool = False
   no_archive: bool = False
   no_publish: bool = False

   def to_dict(self) -> dict:
       return asdict(self)  # noqa


def init_collections(
    schemes_dir: str,
    schemes_mapping: dict[str, str],
    collections_settings_mapping: dict[str, CollectionProps],
) -> list[collections_pb2.Collection]:

    collections = []
    for collection_id, collection_name in schemes_mapping.items():
        with open(f"{schemes_dir}/{collection_id}.json", "r") as file:
            collection_schema = file.read()

        props = collections_settings_mapping.get(collection_id) or CollectionProps()

        if not isinstance(props, CollectionProps):
            raise TypeError("collections_settings_mapping value must be an instance of CollectionProps")

        kwargs = {
            **props.to_dict(),
            "id": collection_id,
            "name": collection_name,
            "schema": collection_schema,
        }
        collection = collections_pb2.Collection(**kwargs)
        collections.append(collection)
    return collections
